stages: 
  - tests
  - build
  - staging
  - deploy
  
image: docker:git

services:
  - docker:dind
  
variables:
  GIT_SUBMODULE_STRATEGY: recursive

run-unit-tests:
  stage: tests
  image: node:alpine
  before_script:
    - npm ci
  script:
    - npm run test


sentry_release:
  only:
    - master
  stage: build

  image: node

  before_script:
    - curl -sL https://sentry.io/get-cli/ | bash
    - wget https://github.com/stedolan/jq/releases/download/jq-1.6/jq-linux64 -O /bin/jq && chmod +x /bin/jq
    - npm i
    - npm run build
    - export APP_VERSION=$(jq -r .version $CI_PROJECT_DIR/package.json)
    - export APP_NAME=$(jq -r .name $CI_PROJECT_DIR/package.json)
    - export SENTRY_VERSION=$APP_NAME@$APP_VERSION

  script:
    - echo "Create a new release $SENTRY_VERSION"
    - export SENTRY_URL=$SENTRY_URL
    - export SENTRY_AUTH_TOKEN=$SENTRY_AUTH_TOKEN
    - export SENTRY_ORG=$SENTRY_ORG
    - export SENTRY_PROJECT=dblog-$CI_PROJECT_NAME
    - sentry-cli releases new $SENTRY_VERSION
    - sentry-cli releases files $SENTRY_VERSION upload-sourcemaps $CI_PROJECT_DIR/dist -x .js -x .map --validate --verbose --rewrite --strip-common-prefix
    - sentry-cli releases finalize $SENTRY_VERSION
    - echo "Finalized release for $SENTRY_VERSION"


build-image:
  only:
    - master
  
  stage: build

  before_script:
    - docker pull wiseteam/engrave-$CI_PROJECT_NAME:staging || true # true to not fail if repository is empty

  script:
    - docker build --pull --cache-from wiseteam/engrave-$CI_PROJECT_NAME:staging . -t wiseteam/engrave-$CI_PROJECT_NAME:$CI_COMMIT_SHORT_SHA -t wiseteam/engrave-$CI_PROJECT_NAME:staging
    - echo $HUB_PASSWORD | docker login -u "$HUB_USERNAME" --password-stdin
    - docker push wiseteam/engrave-$CI_PROJECT_NAME:$CI_COMMIT_SHORT_SHA
    - docker push wiseteam/engrave-$CI_PROJECT_NAME:staging

  after_script:
    - docker images
  
.update-staging:
  stage: staging

  environment: 
    name: staging
    url: https://auth.engrave.dev

  before_script:
    - mkdir -p ~/.docker
    - echo "$TLSCACERT" > ~/.docker/ca.pem
    - echo "$TLSCERT" > ~/.docker/cert.pem
    - echo "$TLSKEY" > ~/.docker/key.pem
    - docker -H $SWARM_HOST_STAGING --tlsverify pull wiseteam/engrave-$CI_PROJECT_NAME:$CI_COMMIT_SHORT_SHA
  script: 
    - docker -H $SWARM_HOST_STAGING --tlsverify service update --image wiseteam/engrave-$CI_PROJECT_NAME:$CI_COMMIT_SHORT_SHA --update-failure-action rollback --update-order start-first engrave_staging_$CI_PROJECT_NAME
  only:
    - master

deploy-engrave:
  stage: deploy
  when: manual
  environment:
    name: engrave
    url: https://auth.engrave.website

  before_script:
    - mkdir -p ~/.docker
    - echo "$ENGRAVE_TLSCACERT" > ~/.docker/ca.pem
    - echo "$ENGRAVE_TLSCERT" > ~/.docker/cert.pem
    - echo "$ENGRAVE_TLSKEY" > ~/.docker/key.pem
    - docker -H $ENGRAVE_SWARM_HOST --tlsverify pull wiseteam/engrave-$CI_PROJECT_NAME:$CI_COMMIT_SHORT_SHA

  script:
    - docker -H $ENGRAVE_SWARM_HOST --tlsverify service update --image wiseteam/engrave-$CI_PROJECT_NAME:$CI_COMMIT_SHORT_SHA --update-failure-action rollback --update-order start-first engrave_$CI_PROJECT_NAME

  only:
    - master
    - tags

deploy-dblog:
  stage: deploy
  when: manual
  environment:
    name: dblog
    url: https://auth.dblog.pl

  before_script:
    - mkdir -p ~/.docker
    - echo "$DBLOG_TLSCACERT" > ~/.docker/ca.pem
    - echo "$DBLOG_TLSCERT" > ~/.docker/cert.pem
    - echo "$DBLOG_TLSKEY" > ~/.docker/key.pem
    - docker -H $DBLOG_SWARM_HOST --tlsverify pull wiseteam/engrave-$CI_PROJECT_NAME:$CI_COMMIT_SHORT_SHA

  script:
    - docker -H $DBLOG_SWARM_HOST --tlsverify service update --image wiseteam/engrave-$CI_PROJECT_NAME:$CI_COMMIT_SHORT_SHA --update-failure-action rollback --update-order start-first dblog_$CI_PROJECT_NAME

  only:
    - master